# struct Socket::UNIXAddress

- Socket::UNIXAddress
- Socket::Address
- Struct
- Value
- Object

##
Overview

UNIX address representation.

Holds the local path of an UNIX address, usually coming from an opened connection (e.g. `Socket#local_address`, `Socket#receive`).

Example:

    require "socket"

    Socket::UNIXAddress.new("/tmp/my.sock")

##
Defined in:

##
Constructors

- .from(sockaddr : Pointer(LibC::Sockaddr), addrlen) : UNIXAddress

  Creates an `UNIXSocket` from the internal OS representation.

- .new(path : String)
- .parse(uri : URI) : UNIXAddress

  Parses a `Socket::UNIXAddress` from an URI.

##
Class Method Summary

- .parse(uri : String)

  Parses a `Socket::UNIXAddress` from an URI.

##
Instance Method Summary

- #==(other : UNIXAddress)
- #path : String
- #to_s(io : IO) : Nil

  Same as `#inspect(io)`.

- #to_unsafe : Pointer(LibC::Sockaddr)

### Instance methods inherited from struct `Socket::Address`

==(other) ==, family : Family family, size : Int32 size, to_unsafe : Pointer(LibC::Sockaddr) to_unsafe

### Constructor methods inherited from struct `Socket::Address`

from(sockaddr : Pointer(LibC::Sockaddr), addrlen) : Address from, new(family : Family, size : Int32) new

### Class methods inherited from struct `Socket::Address`

parse(uri : URI)
parse(uri : String) parse

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.from(sockaddr : Pointer(LibC::Sockaddr), addrlen) : UNIXAddress #

Creates an `UNIXSocket` from the internal OS representation.

def self.new(path : String) #
def self.parse(uri : URI) : UNIXAddress #

Parses a `Socket::UNIXAddress` from an URI.

It expects the URI to include `://` where `scheme` as well as any additional URI components (such as `fragment` or `query`) are ignored.

If `host` is not empty, it will be prepended to `#path` to form a relative path.

    require "socket"

    Socket::UNIXAddress.parse("unix:///foo.sock") # => Socket::UNIXAddress.new("/foo.sock")
    Socket::UNIXAddress.parse("unix://foo.sock")  # => Socket::UNIXAddress.new("foo.sock")

##
Class Method Detail

def self.parse(uri : String) #

Parses a `Socket::UNIXAddress` from an URI.

It expects the URI to include `://` where `scheme` as well as any additional URI components (such as `fragment` or `query`) are ignored.

If `host` is not empty, it will be prepended to `#path` to form a relative path.

    require "socket"

    Socket::UNIXAddress.parse("unix:///foo.sock") # => Socket::UNIXAddress.new("/foo.sock")
    Socket::UNIXAddress.parse("unix://foo.sock")  # => Socket::UNIXAddress.new("foo.sock")

##
Instance Method Detail

def ==(other : UNIXAddress) #
def path : String #
def to_s(io : IO) : Nil #
Description copied from struct Struct

Same as `#inspect(io)`.

def to_unsafe : Pointer(LibC::Sockaddr) #